//
//  SmashViewController.m
//  Smash
//
//  Created by aka on 08/12/22.
//  Copyright Masayuki Akamatsu 2008. All rights reserved.
//

#import "SmashViewController.h"


@implementation SmashViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
// ビューの読み込みが完了した時に呼び出されるメソッド
- (void)viewDidLoad
{
	// スーパー・クラスのメソッドを呼び出す
    [super viewDidLoad];

	// 乱数の初期化
	srand(time(NULL));
	
	// ここではタイマーを動作させない	// 変更
	/*
	// タイマーの作成（動作開始）
	[NSTimer scheduledTimerWithTimeInterval:0.5		// 時間間隔（秒）
									 target:self	// 呼び出すオブジェクト
								   selector:@selector(move:)	// 呼び出すメソッド
								   userInfo:nil		// ユーザ利用の情報オブジェクト
									repeats:YES];	// 繰り返し
	*/
	
	// 効果音の再生を準備
	NSString *path = [[NSBundle mainBundle] pathForResource:@"Smash" ofType:@"caf"];
	NSURL *url = [NSURL fileURLWithPath:path]; 
	AudioServicesCreateSystemSoundID((CFURLRef)url, &soundID);
	
	// 通信を開始 // 追加
	[GameKitHelper sharedInstance].sessionID = @"Smash-X";
	[GameKitHelper sharedInstance].dataDelegate = self;
	[GameKitHelper connect];

}

// 通信の処理 // 追加

// 接続が確立された時に呼び出される	// 追加
- (void)connectionEstablished
{
	// サーバとして接続された場合は
	if ([GameKitHelper sharedInstance].isServer)
	{
		// タイマーの作成（動作開始）
		[NSTimer scheduledTimerWithTimeInterval:0.5		// 時間間隔（秒）
										 target:self	// 呼び出すオブジェクト
									   selector:@selector(move:)	// 呼び出すメソッド
									   userInfo:nil		// ユーザ利用の情報オブジェクト
										repeats:YES];	// 繰り返し
		xOffset = 0;	// 空間のオフセットはなし
	}
	else
	{
		xOffset = kXOffset;	// 空間のオフセットは定義値
	}
	
	// ローカル空間を定義 // 追加
	localSpaceView.bounds = CGRectMake(xOffset, 0, 320, 480);
}

// サーバから位置を受け取る〜クライアントのみ	// 追加
- (void) receivedData: (NSData *) data
{
	// 受け取ったデータから位置を得る
	NSArray *array = [NSKeyedUnarchiver unarchiveObjectWithData:data];
	int x = [[array objectAtIndex:0] intValue];
	int y = [[array objectAtIndex:1] intValue];
	// UFOを移動させる
	[self locateAtX:x andY:y];
}

// タイマーから呼び出され、UFOの位置を決める〜サーバのみ		// 変更
- (void)move:(NSTimer *)timer
{
	// UFOの位置を決める
	int x = rand() % (320 + kXOffset);
	int y = rand() % 480;
	
	// サーバは自分が決めた位置にUFOを移動する
	[self locateAtX:x andY:y];
	
	// クライアントに位置を送る
	NSArray *array = [NSArray arrayWithObjects:[NSNumber numberWithInt:x], [NSNumber numberWithInt:y], nil];
	NSData *data = [NSKeyedArchiver archivedDataWithRootObject:array];
	[GameKitHelper sendData:data];
}

// UFOを指定した位置に移動させる		// 追加
- (void)locateAtX:(int)x andY:(int)y
{
	// アニメーションの定義開始
	[UIView beginAnimations:nil context:nil];
	[UIView setAnimationDuration:0.5];

	// UFOを移動
	target.center = CGPointMake(x, y);

	// アニメーションの定義終了、実行
	[UIView commitAnimations];
}


// UFOがタップされた時に呼び出されるメソッド
- (IBAction)smash
{
	// 効果音を再生
	AudioServicesPlaySystemSound(soundID);
	
	// バイブレーション付きで効果音を再生
	//AudioServicesPlayAlertSound(soundID);
	
	// バイブレーションを発生
	//AudioServicesPlaySystemSound(kSystemSoundID_Vibrate);
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc
{
    [super dealloc];
}

@end
